unit fm1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    New1: TMenuItem;
    mForm2: TMenuItem;
    mForm3: TMenuItem;
    ComboBox1: TComboBox;
    Button1: TButton;
    procedure mForm2Click(Sender: TObject);
    procedure mForm3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    function CreateUniqueForm(FormClass: TFormClass): TFormclass; overload;
    function CreateUniqueForm(fmName: string): TFormclass; overload;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Fm2; // `NSϥ Fm3

{$R *.dfm}

function TForm1.CreateUniqueForm(FormClass:TFormClass):TFormclass;
var
i : integer;
Fm : TForm;
begin
  fm := nil;
  for i := 0 to Screen.FormCount - 1 do
    if Screen.Forms[i] is FormClass then
    begin
      Fm := Screen.Forms[i];
      if Fm.WindowState = wsMinimized then
        Fm.WindowState := wsNormal;
      Fm.BringToFront;
    end;
  if not assigned(fm) then
    fm := FormClass.Create(Self);
  fm.Show;
  result := TFormClass(Fm);
end;

function TForm1.CreateUniqueForm(fmName: string):TFormclass;
begin
  Result := TFormClass(FindClass(fmName));
  try
    try
      CreateUniqueForm(Result);
    except
      on E:Exception do
        ShowMessage(E.Message);
    end;
  except
    ShowMessage(fmname+ ' |إ');
  end;
end;

procedure TForm1.mForm2Click(Sender: TObject);
begin
  CreateUniqueForm(TForm2); //  FormClass Ӷ}
end;

procedure TForm1.mForm3Click(Sender: TObject);
begin
  CreateUniqueForm('TForm3'); //  Form ClassName Ӷ}
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  CreateUniqueForm(ComboBox1.Text); // Τ@rƦ Database ̪ȳiH
end;

end.
